> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.tabs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.tabs.com/_mcp/server.

# Update contract performance obligation

PATCH https://integrators.prod.api.tabsplatform.com/v3/contracts/{id}/performance-obligations/{pobId}
Content-Type: application/json

Reference: https://docs.tabs.com/api-reference/contracts/updatePerformanceObligation

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Tabs External API
  version: 1.0.0
paths:
  /v3/contracts/{id}/performance-obligations/{pobId}:
    patch:
      operationId: integrators-api-contractsv-3-controller-update-performance-obligation
      summary: Update contract performance obligation
      tags:
        - contracts
      parameters:
        - name: id
          in: path
          description: Contract Id
          required: true
          schema:
            type: string
        - name: pobId
          in: path
          description: Performance Obligation Id
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Performance obligation updated successfully
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/Contracts_IntegratorsApiContractsv3Controller_updatePerformanceObligation_Response_200
        '400':
          description: Validation error or performance obligation features not enabled
          content:
            application/json:
              schema:
                description: Any type
        '404':
          description: Contract or performance obligation not found
          content:
            application/json:
              schema:
                description: Any type
        '500':
          description: Internal Server Error
          content:
            application/json:
              schema:
                description: Any type
      requestBody:
        description: Fields to update on the performance obligation
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/UpdatePerformanceObligationForContractDto'
servers:
  - url: https://integrators.prod.api.tabsplatform.com
    description: https://integrators.prod.api.tabsplatform.com
components:
  schemas:
    UpdatePerformanceObligationForContractDtoConsiderationType:
      type: string
      enum:
        - FIXED
        - VARIABLE
      description: Consideration type
      title: UpdatePerformanceObligationForContractDtoConsiderationType
    UpdatePerformanceObligationForContractDtoRecognitionPattern:
      type: string
      enum:
        - STRAIGHT_LINE
        - RECOGNIZE_AS_CONSUMED
        - RECOGNIZE_AS_BILLED
      description: Recognition pattern
      title: UpdatePerformanceObligationForContractDtoRecognitionPattern
    UpdatePerformanceObligationForContractDto:
      type: object
      properties:
        name:
          type: string
          description: The name of the performance obligation
        erpClassId:
          type:
            - string
            - 'null'
          description: >-
            The ID of the integration / ERP class (integration class) for this
            performance obligation
        itemId:
          type:
            - string
            - 'null'
          description: The ID of the integration item
        serviceStartDate:
          type: string
          description: Service start date
        serviceEndDate:
          type: string
          description: Service end date
        considerationType:
          $ref: >-
            #/components/schemas/UpdatePerformanceObligationForContractDtoConsiderationType
          description: Consideration type
        recognitionPattern:
          $ref: >-
            #/components/schemas/UpdatePerformanceObligationForContractDtoRecognitionPattern
          description: Recognition pattern
      title: UpdatePerformanceObligationForContractDto
    RecognizedRevenueAtomResponseDto:
      type: object
      properties:
        timeframe:
          type: string
          description: Month in YYYY-MM format
        total:
          type: string
          description: Recognized revenue amount as a decimal string
      required:
        - timeframe
        - total
      title: RecognizedRevenueAtomResponseDto
    PerformanceObligationDetailResponseDto:
      type: object
      properties:
        id:
          type: string
          description: Unique identifier for the performance obligation
        name:
          type:
            - string
            - 'null'
          description: Name of the performance obligation
        billingTermGroupId:
          type:
            - string
            - 'null'
          description: Billing term group ID (foreign key)
        billingTermGroupName:
          type:
            - string
            - 'null'
          description: Billing term group name
        itemId:
          type:
            - string
            - 'null'
          description: ID of the associated integrationitem
        itemName:
          type:
            - string
            - 'null'
          description: Name of the associated integrationitem
        erpClassId:
          type:
            - string
            - 'null'
          description: ID of the ERP class
        erpClassName:
          type:
            - string
            - 'null'
          description: Name of the ERP class
        category:
          type:
            - string
            - 'null'
          description: Revenue category
        productId:
          type:
            - string
            - 'null'
          description: ID of the associated product
        productName:
          type:
            - string
            - 'null'
          description: Name of the associated product
        serviceStartDate:
          type: string
          format: date-time
          description: Service start date
        serviceEndDate:
          type: string
          format: date-time
          description: Service end date
        transactionPrice:
          type: string
          description: Transaction price as a decimal string
        billingTermIds:
          type: array
          items:
            type: string
          description: Array of billing term IDs linked to this POB via the BTG
        considerationType:
          type:
            - string
            - 'null'
          description: Consideration type
        recognitionPattern:
          type:
            - string
            - 'null'
          description: Revenue recognition pattern
        eventTypeId:
          type:
            - string
            - 'null'
          description: Event type ID
        eventTypeName:
          type:
            - string
            - 'null'
          description: Event type name
        hasSentInvoice:
          type: boolean
          description: >-
            Whether POB has any invoice sent to ERP (SENT, PAID, PARTIALLY_PAID,
            DONE)
        recognizedRevenue:
          type: array
          items:
            $ref: '#/components/schemas/RecognizedRevenueAtomResponseDto'
          description: Monthly recognized revenue entries for this performance obligation
        createdAt:
          type: string
          format: date-time
          description: Timestamp when the performance obligation was created
        updatedAt:
          type: string
          format: date-time
          description: Timestamp when the performance obligation was last updated
      required:
        - id
        - name
        - billingTermGroupId
        - billingTermGroupName
        - itemId
        - itemName
        - erpClassId
        - erpClassName
        - category
        - productId
        - productName
        - serviceStartDate
        - serviceEndDate
        - transactionPrice
        - billingTermIds
        - considerationType
        - recognitionPattern
        - eventTypeId
        - eventTypeName
        - hasSentInvoice
        - recognizedRevenue
        - createdAt
        - updatedAt
      title: PerformanceObligationDetailResponseDto
    IntegratorsApiErrorDetails:
      type: object
      properties: {}
      description: Additional details about the error
      title: IntegratorsApiErrorDetails
    IntegratorsApiError:
      type: object
      properties:
        code:
          type: number
          format: double
          description: API response code
        message:
          type: string
          description: API response message
        details:
          $ref: '#/components/schemas/IntegratorsApiErrorDetails'
          description: Additional details about the error
      required:
        - code
        - message
      title: IntegratorsApiError
    Contracts_IntegratorsApiContractsv3Controller_updatePerformanceObligation_Response_200:
      type: object
      properties:
        payload:
          $ref: '#/components/schemas/PerformanceObligationDetailResponseDto'
          description: Response payload, will be empty when success is false
        success:
          type: boolean
          description: Boolean with true=success, false=failure
        message:
          type: string
          description: Plain-text description of the result
        error:
          $ref: '#/components/schemas/IntegratorsApiError'
          description: json element with any error messages or warnings
      required:
        - payload
        - success
        - message
        - error
      title: >-
        Contracts_IntegratorsApiContractsv3Controller_updatePerformanceObligation_Response_200
  securitySchemes:
    custom-header:
      type: apiKey
      in: header
      name: Authorization

```

## Examples



**Request**

```json
{}
```

**Response**

```json
{
  "payload": {
    "id": "123e4567-e89b-12d3-a456-426614174000",
    "name": "Annual Subscription",
    "billingTermGroupId": "123e4567-e89b-12d3-a456-426614174000",
    "billingTermGroupName": "Towing Services",
    "itemId": "123e4567-e89b-12d3-a456-426614174000",
    "itemName": "Enterprise License",
    "erpClassId": "123e4567-e89b-12d3-a456-426614174000",
    "erpClassName": "Software Revenue",
    "category": "SaaS",
    "productId": "123e4567-e89b-12d3-a456-426614174000",
    "productName": "Enterprise Plan",
    "serviceStartDate": "2024-01-01",
    "serviceEndDate": "2024-12-31",
    "transactionPrice": "1000.50",
    "billingTermIds": [
      "123e4567-e89b-12d3-a456-426614174000"
    ],
    "considerationType": "FIXED",
    "recognitionPattern": "STRAIGHT_LINE",
    "eventTypeId": "123e4567-e89b-12d3-a456-426614174000",
    "eventTypeName": "Tow Completion",
    "hasSentInvoice": true,
    "recognizedRevenue": [
      {
        "timeframe": "2024-01",
        "total": "1000.50"
      }
    ],
    "createdAt": "2024-01-01T00:00:00.000Z",
    "updatedAt": "2024-01-01T00:00:00.000Z"
  },
  "success": true,
  "message": "string",
  "error": {
    "code": 1.1,
    "message": "string",
    "details": {}
  }
}
```

**SDK Code**

```python
import requests

url = "https://integrators.prod.api.tabsplatform.com/v3/contracts/123e4567-e89b-12d3-a456-426614174000/performance-obligations/123e4567-e89b-12d3-a456-426614174000"

payload = {}
headers = {
    "Authorization": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://integrators.prod.api.tabsplatform.com/v3/contracts/123e4567-e89b-12d3-a456-426614174000/performance-obligations/123e4567-e89b-12d3-a456-426614174000';
const options = {
  method: 'PATCH',
  headers: {Authorization: '<apiKey>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://integrators.prod.api.tabsplatform.com/v3/contracts/123e4567-e89b-12d3-a456-426614174000/performance-obligations/123e4567-e89b-12d3-a456-426614174000"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("PATCH", url, payload)

	req.Header.Add("Authorization", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://integrators.prod.api.tabsplatform.com/v3/contracts/123e4567-e89b-12d3-a456-426614174000/performance-obligations/123e4567-e89b-12d3-a456-426614174000")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Patch.new(url)
request["Authorization"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.patch("https://integrators.prod.api.tabsplatform.com/v3/contracts/123e4567-e89b-12d3-a456-426614174000/performance-obligations/123e4567-e89b-12d3-a456-426614174000")
  .header("Authorization", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PATCH', 'https://integrators.prod.api.tabsplatform.com/v3/contracts/123e4567-e89b-12d3-a456-426614174000/performance-obligations/123e4567-e89b-12d3-a456-426614174000', [
  'body' => '{}',
  'headers' => [
    'Authorization' => '<apiKey>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://integrators.prod.api.tabsplatform.com/v3/contracts/123e4567-e89b-12d3-a456-426614174000/performance-obligations/123e4567-e89b-12d3-a456-426614174000");
var request = new RestRequest(Method.PATCH);
request.AddHeader("Authorization", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://integrators.prod.api.tabsplatform.com/v3/contracts/123e4567-e89b-12d3-a456-426614174000/performance-obligations/123e4567-e89b-12d3-a456-426614174000")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PATCH"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```